#!/bin/sh

set -e

MYNAME=downup

report()
{
        echo "${MYNAME}: $*"
}

report_err()
{
        report "Error: $*" >&2
}


IFDOWNSCRIPT="$(mktemp -t resolvconf-downup-down.XXXXXX)" && {
	IFUPSCRIPT="$(mktemp -t resolvconf-downup-up.XXXXXX)" && {
		echo "echo resolvconf-downup will now ifdown all active interfaces." > "$IFDOWNSCRIPT"
		sed -n -e '/^lo=/s/.*//' -e '/^\([^=]\+\)=.*/ {s//ifdown \1/;G;h;}' -e '${g;s/\n$//;p;}' /etc/network/ifstate >> $IFDOWNSCRIPT
		echo "echo resolvconf-downup will now ifup all interfaces it downed." > "$IFUPSCRIPT"
		sed -n -e '/^$/b; /^lo=/b; s/^/ifup /p' /etc/network/ifstate >> "$IFUPSCRIPT"
		echo "echo All interfaces have been downupped." >> "$IFUPSCRIPT"
		set +e
		. "$IFDOWNSCRIPT"
		. "$IFUPSCRIPT"
		set -e
		rm -f "$IFUPSCRIPT"
		unset IFUPSCRIPT
	} || report_err "Failure while upping interfaces"
	rm -f "$IFDOWNSCRIPT"
	unset IFDOWNSCRIPT
} || report_err "Failure while downing interfaces"

# Restart DNS caches
[ -x /etc/init.d/dnsmasq ] && pidof dnsmasq > /dev/null && /etc/init.d/dnsmasq restart
[ -x /etc/init.d/bind9 ] && pidof named > /dev/null && /etc/init.d/bind9 restart
# Bind (version 8) currently lacks resolvconf support
#[ -x /etc/init.d/bind ] && pidof named > /dev/null && /etc/init.d/bind restart

